﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;
using Microsoft.Win32;

namespace ExcelAddinSample2
{
    /// <summary>
    ///   Add-in Express XLL Add-in Module
    /// </summary>
    [ComVisible(true)]
    public partial class XLLModule1 : AddinExpress.MSO.ADXXLLModule
    {
        public XLLModule1()
        {
            InitializeComponent();
            // Please add any initialization code to the OnInitialize event handler
        }
 
        #region Add-in Express automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void RegisterXLL(Type t)
        {
            AddinExpress.MSO.ADXXLLModule.RegisterXLLInternal(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void UnregisterXLL(Type t)
        {
            AddinExpress.MSO.ADXXLLModule.UnregisterXLLInternal(t);
        }
 
        #endregion
 
        public static new XLLModule1 CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXXLLModule.CurrentInstance as XLLModule1;
            }
        }

        #region Define your UDFs in this section
 
        /// <summary>
        /// The container for user-defined functions (UDFs). Every UDF is a public static (Public Shared in VB.NET) method that returns a value of any base type: string, double, integer.
        /// </summary>
        internal static class XLLContainer
        {
            /// <summary>
            /// Required by Add-in Express. Please do not modify this method.
            /// </summary>
            internal static XLLModule1 Module
            {
                get
                {
                    return AddinExpress.MSO.ADXXLLModule.
                        CurrentInstance as ExcelAddinSample2.XLLModule1;
                }
            }

            public static string MainXLLFunction(object arg)
            {
                return "Hello (main XLL module)";
            }
 
            #region Sample function
 
            // Demonstrates how to handle all parameter types available for UDFs.
            // Uncomment the code, click Register Add-in Express Project in the Build menu, and run Excel.
 
            //public static string AllSupportedExcelTypes(object arg)
            //{
            //    if (arg is double)
            //        return "Double: " + (double)arg;
            //    else if (arg is string)
            //        return "String: " + (string)arg;
            //    else if (arg is bool)
            //        return "Boolean: " + (bool)arg;
            //    else if (arg is AddinExpress.MSO.ADXExcelError)
            //        return "ExcelError: " + arg.ToString();
            //    else if (arg is object[,])
            //        return string.Format("Array[{0},{1}]", ((object[,])arg).GetLength(0), ((object[,])arg).GetLength(1));
            //    else if (arg is System.Reflection.Missing)
            //        return "Missing";
            //    else if (arg == null)
            //        return "Empty";
            //    else if (arg is AddinExpress.MSO.ADXExcelRef)
            //    {
            //        AddinExpress.MSO.ADXExcelRef reference = arg as AddinExpress.MSO.ADXExcelRef;
            //        return string.Format("Reference [{0},{1},{2},{3}]", reference.ColumnFirst, reference.RowFirst, reference.ColumnLast, reference.RowLast);
            //    }
            //    else if (arg is short)
            //        return "Short: " + (short)arg;
            //    else
            //        return "Unknown Type";
            //}
 
            #endregion
 
        }
 
        #endregion

        private void XLLModule1_OnInitialize(object sender, EventArgs e)
        {
            RegistryKey key = Registry.CurrentUser.OpenSubKey("Software\\Microsoft\\Office\\Excel\\Addins\\ExcelAddinSample2.AddinModule\\Settings", false);
            if (key != null)
                try
                {
                    bool xll1Enabled = Convert.ToBoolean(key.GetValue("XLL1", true));
                    bool xll2Enabled = Convert.ToBoolean(key.GetValue("XLL2", true));

                    if (!xll1Enabled)
                        this.Modules.Remove(this.adxxllAdditionalModuleItem1);
                    if (!xll2Enabled)
                        this.Modules.Remove(this.adxxllAdditionalModuleItem2);
                }
                finally { key.Close(); }

        }

        private void XLLModule1_OnBeforeFunctionAdd(object sender, ADXExcelFunctionAddEventArgs e)
        {
            // TODO - one more way:
            // see e.Method and e.cancel
        }
    }
}

